## paraview 5.4.1+dfsg4

=== CMakeLists.txt ===
#==========================================================================
#
#     Program: ParaView
#
#     Copyright (c) 2005-2008 Sandia Corporation, Kitware Inc.
#     All rights reserved.
#
#     ParaView is a free software; you can redistribute it and/or modify it
#     under the terms of the ParaView license version 1.2.
#
#     See License_v1.2.txt for the full ParaView license.
#     A copy of this license can be obtained by contacting
#     Kitware Inc.
#     28 Corporate Drive
#     Clifton Park, NY 12065
#     USA
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR
#  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
#  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#==========================================================================
cmake_minimum_required(VERSION 3.3)

project(ParaView)

# Disallow in-source build
if ("${ParaView_SOURCE_DIR}"  STREQUAL "${ParaView_BINARY_DIR}")
  message(FATAL_ERROR
    "ParaView requires an out of source Build. "
    "Please create a separate binary directory and run CMake there.")
endif()

#------------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

#------------------------------------------------------------------------------
# Choose static or shared libraries.
option(BUILD_SHARED_LIBS "Build VTK with shared libraries." ON)
set(VTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

#------------------------------------------------------------------------------
# Protect against a stampede of static links at the same time.
if (NOT BUILD_SHARED_LIBS)
  set(PV_EXE_JOB_LINK_POOL static_exe_link)
  set_property(GLOBAL APPEND PROPERTY
    JOB_POOLS static_exe_link=1)
endif ()

#-------------------------------------------------------------------------------
set (ParaView_CMAKE_BINARY_DIR "${ParaView_BINARY_DIR}/CMake")
set (ParaView_CMAKE_DIR "${ParaView_SOURCE_DIR}/CMake")

#-------------------------------------------------------------------------------
# Set up CMAKE_MODULE_PATH
set (CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  ${ParaView_CMAKE_BINARY_DIR}
  ${ParaView_CMAKE_DIR}
)

# Use the new version of the variable names for output of build process.
# Make sure these are consistent with what VTK sets.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")

include(Utilities/Git/Git.cmake)
include(ParaViewDetermineVersion)
include(CMakeDependentOption)
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# Setup ParaView Environment
#------------------------------------------------------------------------------
# Determine ParaView Source Version
# Hardcoded version variables are readin from a separate file. This makes it
# easier to have a script to update version numbers automatically.
file(STRINGS version.txt version_txt)
extract_version_components("${version_txt}" "PARAVIEW")
determine_version(${ParaView_SOURCE_DIR} ${GIT_EXECUTABLE} "PARAVIEW")

# Setup some cross compiling related things.
if (CMAKE_CROSSCOMPILING AND NOT COMPILE_TOOLS_IMPORTED)
  find_package (ParaViewCompileTools REQUIRED)
  # this keeps VTK sub-dir from trying to import VTKCompileTools.
  set (COMPILE_TOOLS_IMPORTED TRUE)
endif()

#------------------------------------------------------------------------------
# Setup install directories (we use names with VTK_ prefix, since ParaView now
# is built as a custom "VTK" library.
if(NOT VTK_INSTALL_RUNTIME_DIR)
  set(VTK_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT VTK_INSTALL_LIBRARY_DIR)
  set(VTK_INSTALL_LIBRARY_DIR lib/paraview-${PARAVIEW_VERSION})
endif()
# ParaView installs the vtk python modules specifically to appropriate locations.
if(NOT VTK_INSTALL_PYTHON_MODULE_DIR)
  set (VTK_INSTALL_PYTHON_MODULE_DIR "${VTK_INSTALL_LIBRARY_DIR}/site-packages" CACHE
    INTERNAL "Directory where python modules will be installed")
endif()
if(NOT VTK_BUILD_PYTHON_MODULE_DIR)
  set (VTK_BUILD_PYTHON_MODULE_DIR "${CMAKE_BINARY_DIR}/lib/site-packages" CACHE
    INTERNAL "Directory where python modules will be built")
endif()
if(NOT VTK_INSTALL_ARCHIVE_DIR)
  set(VTK_INSTALL_ARCHIVE_DIR lib/paraview-${PARAVIEW_VERSION})
endif()
if(NOT VTK_INSTALL_INCLUDE_DIR)
  set(VTK_INSTALL_INCLUDE_DIR include/paraview-${PARAVIEW_VERSION})
endif()
if(NOT VTK_INSTALL_DATA_DIR)
  set(VTK_INSTALL_DATA_DIR share/paraview-${PARAVIEW_VERSION})
endif()
if(NOT VTK_INSTALL_DOC_DIR)
  set(VTK_INSTALL_DOC_DIR share/doc/paraview-${PARAVIEW_VERSION})
endif()
if(NOT VTK_INSTALL_PACKAGE_DIR)
  set(VTK_INSTALL_PACKAGE_DIR "lib/cmake/paraview-${PARAVIEW_VERSION}")
endif()
if(NOT VTK_INSTALL_DOXYGEN_DIR)
  set(VTK_INSTALL_DOXYGEN_DIR ${VTK_INSTALL_DOC_DIR}/doxygen)
endif()
if(NOT VTK_INSTALL_EXPORT_NAME)
  set(VTK_INSTALL_EXPORT_NAME ParaViewTargets)
endif()
if(NOT VTK_MODULES_DIR)
  set(VTK_MODULES_DIR "${ParaView_BINARY_DIR}/${VTK_INSTALL_PACKAGE_DIR}/Modules")
endif()
if(NOT PARAVIEW_WWW_DIR)
  set(PARAVIEW_WWW_DIR "${ParaView_BINARY_DIR}/www")
endif()
set(PARAVIEW_MODULES_DIR ${VTK_MODULES_DIR})

if (NOT DEFINED VTK_CUSTOM_LIBRARY_SUFFIX)
  set (VTK_CUSTOM_LIBRARY_SUFFIX "-pv${PARAVIEW_VERSION}")
endif()

# Handle the target export file, this is used if building against a build tree.
if(NOT VTK_EXPORTS_FILE)
  set(VTK_EXPORTS_FILE "${ParaView_BINARY_DIR}/VTK/${VTK_INSTALL_EXPORT_NAME}.cmake")
endif()
file(REMOVE "${VTK_EXPORTS_FILE}")


if(NOT PV_INSTALL_PLUGIN_DIR)
  if (WIN32)
    set (PV_INSTALL_PLUGIN_DIR ${VTK_INSTALL_RUNTIME_DIR})
  else ()
    set (PV_INSTALL_PLUGIN_DIR ${VTK_INSTALL_LIBRARY_DIR})
  endif()
endif()

# Disable installing of the Qt Designer plugin. There's no need for it in
# ParaView install rules.
set (VTK_INSTALL_NO_QT_PLUGIN TRUE)

# Disable installing of the vtkpython executables.
set (VTK_INSTALL_NO_PYTHON_EXES TRUE)

# for temporary backwards compatibility.
set (PV_INSTALL_BIN_DIR ${VTK_INSTALL_RUNTIME_DIR})
set (PV_INSTALL_LIB_DIR ${VTK_INSTALL_ARCHIVE_DIR})
set (PV_INSTALL_EXPORT_NAME ${VTK_INSTALL_EXPORT_NAME})

# Setting this ensures that "make install" will leave rpaths to external
# libraries (not part of the build-tree e.g. Qt, ffmpeg, etc.) intact on
# "make install". This ensures that one can install a version of ParaView on the
# build machine without any issues. If this not desired, simply specify
# CMAKE_INSTALL_RPATH_USE_LINK_PATH when configuring Paraview and
# "make install" will strip all rpaths, which is default behavior.
if(NOT CMAKE_INSTALL_RPATH_USE_LINK_PATH )
  set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# Define ParaView specific options.
#------------------------------------------------------------------------------
option(BUILD_TESTING "Build ParaView Testing" OFF)
option(BUILD_EXAMPLES "Build ParaView examples" OFF)
option(BUILD_SHARED_LIBS "Build ParaView using shared libraries" ON)
option(PARAVIEW_BUILD_QT_GUI "Enable ParaView Qt-based client" ON)
option(PARAVIEW_USE_VTKM "Build ParaView with VTKm many-core filters" OFF)
option(PARAVIEW_USE_MPI "Enable MPI support for parallel computing" OFF)
option(PARAVIEW_USE_OSPRAY "Build ParaView with OSPRay Ray Traced rendering" OFF)
option(PARAVIEW_USE_OPENVR "Build ParaView with OpenVR rendering" OFF)
set(VTK_OPENVR_OBJECT_FACTORY OFF
    CACHE INTERNAL "ParaView requires the OpenVR factory be disabled" FORCE)
option(PARAVIEW_USE_VISITBRIDGE "Build ParaView with VisIt readers." OFF)

# Xdmf3 is not ON by default since it depends on Boost.
option(PARAVIEW_ENABLE_XDMF3 "Enable Xdmf3 support (requires Boost)." OFF)

if (UNIX)
  option(PARAVIEW_ENABLE_FFMPEG "Enable FFMPEG Support." OFF)
endif()

if (UNIX)
  # Since development installs are currently being tested only on linuxes. We
  # can support these for other platforms if time permits.
  option(PARAVIEW_INSTALL_DEVELOPMENT_FILES
    "When enabled, \"make install\" will install development files" OFF)
endif()

cmake_dependent_option(PARAVIEW_USE_MPI_SSEND
  "Use MPI synchronous-send commands for communication" OFF
  "PARAVIEW_USE_MPI" OFF)
cmake_dependent_option(PARAVIEW_USE_ICE_T
  "Enable IceT (needed for parallel rendering)" ON
  "PARAVIEW_USE_MPI" OFF)
cmake_dependent_option(PARAVIEW_INITIALIZE_MPI_ON_CLIENT
  "Initialize MPI on client-processes by default. Can be overridden using command line arguments"
  OFF
  "PARAVIEW_USE_MPI" OFF)

mark_as_advanced(PARAVIEW_USE_ICE_T
  PARAVIEW_USE_MPI_SSEND
  PARAVIEW_INITIALIZE_MPI_ON_CLIENT)

cmake_dependent_option(PARAVIEW_ENABLE_QT_SUPPORT
  "Build ParaView with Qt support (without GUI)" OFF
  "NOT PARAVIEW_BUILD_QT_GUI" ON)

# Add an option to enable using Qt Webkit for widgets, as needed.
# Default is OFF. We don't want to depend on WebKit unless absolutely needed.
cmake_dependent_option(PARAVIEW_USE_QTWEBKIT
  "Use Qt WebKit components as needed." OFF
  "PARAVIEW_ENABLE_QT_SUPPORT" OFF)
mark_as_advanced(PARAVIEW_USE_QTWEBKIT)

# Add an option to enable using Qt Help, as needed.
# Default is ON to enable integrated help/documentation.
cmake_dependent_option(PARAVIEW_USE_QTHELP
  "Use Qt Help infrastructure as needed." ON
  "PARAVIEW_ENABLE_QT_SUPPORT" OFF)
mark_as_advanced(PARAVIEW_USE_QTHELP)

# This option controls the behavior of the build_help_project function.  If it is
# on then the .qch file will be generated, if not then the function does nothing.
cmake_dependent_option(PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION
       "Build the ParaView help menu documentation for ParaView and its plugins" ON
       "PARAVIEW_BUILD_QT_GUI" ON)
mark_as_advanced(PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION)


# If PARAVIEW_BUILD_QT_GUI is OFF, provide an option to the user to turn other command line
# executables ON/OFF.
cmake_dependent_option(PARAVIEW_ENABLE_COMMANDLINE_TOOLS
  "Build ParaView command-line tools" ON
  "NOT PARAVIEW_BUILD_QT_GUI" ON)

option(PARAVIEW_ENABLE_PYTHON "Enable/Disable Python scripting support" OFF)
cmake_dependent_option(PARAVIEW_USE_UNIFIED_BINDINGS "If enabled, Python bindings will back the ClientServer wrapping implementation" OFF
  PARAVIEW_ENABLE_PYTHON OFF)
mark_as_advanced(PARAVIEW_USE_UNIFIED_BINDINGS)
cmake_dependent_option(PARAVIEW_ENABLE_MATPLOTLIB "Enable/Disable Python scripting support" ON
  "PARAVIEW_ENABLE_PYTHON" OFF)
mark_as_advanced(PARAVIEW_ENABLE_MATPLOTLIB)

# If building on Unix with MPI enabled, we will present another option to
# enable building of CosmoTools VTK extensions. This option is by default
# OFF and set to OFF if ParaView is not built with MPI.
if (UNIX)
  cmake_dependent_option(PARAVIEW_ENABLE_COSMOTOOLS
    "Build ParaView with CosmoTools VTK Extensions" OFF
    "PARAVIEW_USE_MPI" OFF)
  mark_as_advanced(PARAVIEW_ENABLE_COSMOTOOLS)
endif()

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
project(ParaViewExamples)

option(ENABLE_CATALYST "Enable Catalyst Examples" OFF)

set(paraview_components)
if (ENABLE_CATALYST)
  list(APPEND paraview_components vtkPVPythonCatalyst)
endif ()

if (paraview_components)
  list(INSERT paraview_components 0 COMPONENTS)
endif ()
find_package(ParaView REQUIRED ${paraview_components})
include(${PARAVIEW_USE_FILE})

add_subdirectory(Plugins/Filter)
add_subdirectory(Plugins/ParametricSource)
add_subdirectory(Plugins/SMProxy)
add_subdirectory(Plugins/Representation)
add_subdirectory(Plugins/HiddenLinesRemoval)

if (ENABLE_CATALYST)
  add_subdirectory(Catalyst)
endif ()

if (PARAVIEW_BUILD_QT_GUI)
  add_subdirectory(Plugins/Autostart)
  add_subdirectory(Plugins/DockWidget)
  add_subdirectory(Plugins/GUIToolBar)
  add_subdirectory(Plugins/LagrangianIntegrationModel)
  add_subdirectory(Plugins/PropertyWidgets)
  add_subdirectory(Plugins/Reader)
  add_subdirectory(Plugins/ReaderXMLOnly)
  add_subdirectory(Plugins/RenderPassViews)
  # TODO: update this plugin to use the pipeline controller instead.
  #add_subdirectory(Plugins/RepresentationBehavior)
  add_subdirectory(Plugins/SourceToolbar)
  add_subdirectory(Plugins/Writer)

  add_subdirectory(CustomApplications/Clone1)
  add_subdirectory(CustomApplications/Clone2)
  add_subdirectory(CustomApplications/Demo0)
  add_subdirectory(CustomApplications/Demo1)
  add_subdirectory(CustomApplications/MultiServerClient)
# TODO Update this custom application to load only specific data types.
#  add_subdirectory(CustomApplications/Spreadsheet) 
endif()

if (TARGET vtkIOVisItBridge)
  # add_subdirectory(Plugins/VisItReader)
endif ()

=== VTK/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

# Set a consistent MACOSX_RPATH default across all CMake versions.
# When CMake 2.8.12 is required, change this default to 1.
# When CMake 3.0.0 is required, remove this block (see CMP0042).
if(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH 0)
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Android" AND CMAKE_VERSION VERSION_LESS 3.7)
  message(FATAL_ERROR "CMake 3.7 or above is required to build for Android")
endif()

project(VTK)

#-----------------------------------------------------------------------------
# Minimum compiler version check: GCC >= 4.6
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.6)
  message(FATAL_ERROR "GCC 4.6 or later is required.")
endif ()

#-----------------------------------------------------------------------------
# Minimum compiler version check: LLVM Clang >= 3.0
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.0)
  message(FATAL_ERROR "LLVM Clang 3.0 or later is required.")
endif ()

#-----------------------------------------------------------------------------
# Minimum compiler version check: Apple Clang >= 3.0 (Xcode 4.2)
if (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.0)
  message(FATAL_ERROR "Apple Clang 3.0 or later is required.")
endif ()

#-----------------------------------------------------------------------------
# Minimum compiler version check: Microsoft C/C++ >= 17.0 (aka VS 2012 aka VS 11.0)
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 17.0)
  message(FATAL_ERROR "Microsoft Visual Studio 2012 or later is required.")
endif ()

#-----------------------------------------------------------------------------
# Minimum compiler version check: Intel C++ (ICC) >= 14
if (CMAKE_CXX_COMPILER_ID STREQUAL "Intel" AND
    CMAKE_CXX_COMPILER_VERSION VERSION_LESS 14.0)
  message(FATAL_ERROR "Intel C++ (ICC) 14.0 or later is required.")
endif ()

# Make sure we have C++11 enabled.
if(NOT VTK_IGNORE_CMAKE_CXX11_CHECKS)
  # Needed to make sure libraries and executables not built by the
  # vtkModuleMacros still have the C++11 compiler flags enabled
  # Wrap this in an escape hatch for unknown compilers
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED True)
  set(CMAKE_CXX_EXTENSIONS False)
endif()


# Objective-C++ compile flags.
# CMake has no equivalent of CMAKE_CXX_FLAGS for Objective-C++ (bug #4756)
# so we provide this in case the user needs to specify flags specifically
# for Objective-C++ source files.  For example, to build with garbage
# collection support, the -fobjc-gc flag would be used.
IF(APPLE)
  SET(VTK_OBJCXX_FLAGS_DEFAULT "")
  SET(VTK_REQUIRED_OBJCXX_FLAGS ${VTK_OBJCXX_FLAGS_DEFAULT} CACHE STRING "Extra flags for Objective-C++ compilation")
  MARK_AS_ADVANCED(VTK_REQUIRED_OBJCXX_FLAGS)
ENDIF()

set(VTK_CMAKE_DIR "${VTK_SOURCE_DIR}/CMake")
set(CMAKE_MODULE_PATH ${VTK_CMAKE_DIR} ${CMAKE_MODULE_PATH})

include(vtkModuleMacros)
include(vtkExternalData)

#-----------------------------------------------------------------------------
# Forbid downloading resources from the network during a build. This helps
# when building on systems without network connectivity to determine which
# resources much be obtained manually and made available to the build.
option(VTK_FORBID_DOWNLOADS "Do not download source code or data from the network" OFF)
mark_as_advanced(VTK_FORBID_DOWNLOADS)
macro(vtk_download_attempt_check _name)
  if(VTK_FORBID_DOWNLOADS)
    message(SEND_ERROR "Attempted to download ${_name} when VTK_FORBID_DOWNLOADS is ON")
  endif()
endmacro()

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

# Test input data staging directory.
file(RELATIVE_PATH vtk_reldir "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}")
set(VTK_TEST_DATA_DIR "${ExternalData_BINARY_ROOT}/${vtk_reldir}/Testing")

# Test input data directory.
set(VTK_TEST_INPUT_DIR "${VTK_SOURCE_DIR}/Testing/Data")

# Test output directory.
set(VTK_TEST_OUTPUT_DIR "${VTK_BINARY_DIR}/Testing/Temporary")

# Set up our directory structure for output libraries and binaries
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/bin")
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  if(UNIX)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/lib")
  else()
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/bin")
  endif()
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${VTK_BINARY_DIR}/lib")
endif()
mark_as_advanced(CMAKE_RUNTIME_OUTPUT_DIRECTORY
  CMAKE_LIBRARY_OUTPUT_DIRECTORY
  CMAKE_ARCHIVE_OUTPUT_DIRECTORY
  )

include(vtkVersion)
set(VTK_VERSION
    "${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}.${VTK_BUILD_VERSION}")

#-----------------------------------------------------------------------------
# Do we want examples built?
OPTION(BUILD_EXAMPLES "Build VTK examples." OFF)

#-----------------------------------------------------------------------------
if(NOT EXISTS "${VTK_SOURCE_DIR}/.ExternalData/README.rst")
  # This file is always present in version-controlled source trees
  # so we must have been extracted from a source tarball with no
  # data objects needed for testing.  Turn off tests by default
  # since enabling them requires network access or manual data
  # store configuration.
  option(BUILD_TESTING "Build the testing tree." OFF)
endif()
include(CTest)

option(VTK_IOS_BUILD "Build vtk.framework for iOS" OFF)
if (VTK_IOS_BUILD)
  include(vtkiOS)
  return()
endif()

option(VTK_ANDROID_BUILD "Build VTK for Android" OFF)
if (VTK_ANDROID_BUILD)
  include(vtkAndroid)
  return()
endif()

# some specific defaults for Andriod to give folks
# a reasonable starting point
if (ANDROID OR APPLE_IOS)
  SET( CMAKE_REQUIRE_LARGE_FILE_SUPPORT 2
       CACHE STRING "Result from TRY_RUN" FORCE)
  SET( CMAKE_REQUIRE_LARGE_FILE_SUPPORT__TRYRUN_OUTPUT ""
       CACHE STRING "Output from TRY_RUN" FORCE)
  SET( KWSYS_LFS_WORKS 2
     CACHE STRING "Result from TRY_RUN" FORCE)
  SET( KWSYS_LFS_WORKS__TRYRUN_OUTPUT ""
     CACHE STRING "Output from TRY_RUN" FORCE)

  if (APPLE_IOS)
    unset(OPENGL_INCLUDE_DIR CACHE)
    find_path(OPENGL_INCLUDE_DIR ES3/gl.h
              ${CMAKE_OSX_SYSROOT}/System/Library/Frameworks/OpenGLES.framework/Headers
              ${_OPENGL_INCLUDE_DIR})
    find_library(OPENGL_gl_LIBRARY
       NAMES OpenGLES
       PATHS
         ${CMAKE_OSX_SYSROOT}/System/Library/Frameworks
         ${_OPENGL_LIB_PATH}
       )
  elseif (ANDROID)
    unset(OPENGL_INCLUDE_DIR CACHE)
    unset(OPENGL_gl_LIBRARY CACHE)
    unset(OPENGL_egl_LIBRARY CACHE)

    find_path(OPENGL_INCLUDE_DIR GLES3/gl3.h)
    find_library(OPENGL_gl_LIBRARY NAMES GLESv3)
    find_library(OPENGL_egl_LIBRARY NAMES EGL)
  endif()
else()
  # Choose static or shared libraries.
  option(BUILD_SHARED_LIBS "Build VTK with shared libraries." ON)
endif()

# default to not using the system GLEW as ours has fixes in it right now
set(VTK_USE_SYSTEM_GLEW OFF CACHE BOOL "do not use a system glew")

set(VTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

#-----------------------------------------------------------------------------
# VTK installation structure
if(NOT VTK_INSTALL_RUNTIME_DIR)
  set(VTK_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT VTK_INSTALL_LIBRARY_DIR)
  set(VTK_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT VTK_INSTALL_ARCHIVE_DIR)
  set(VTK_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT VTK_INSTALL_INCLUDE_DIR)
  set(VTK_INSTALL_INCLUDE_DIR include/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_DATA_DIR)
  set(VTK_INSTALL_DATA_DIR share/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_DOC_DIR)
  set(VTK_INSTALL_DOC_DIR share/doc/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_PACKAGE_DIR)
  set(VTK_INSTALL_PACKAGE_DIR "lib/cmake/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION}")
endif()
if(NOT VTK_INSTALL_DOXYGEN_DIR)
  set(VTK_INSTALL_DOXYGEN_DIR ${VTK_INSTALL_DOC_DIR}/doxygen)
endif()
if(NOT VTK_INSTALL_TCL_DIR)
  # tclsh searches <prefix>/lib/tcltk and its subdirectories for pkgIndex.tcl files
  set(VTK_INSTALL_TCL_DIR lib/tcltk/vtk-${VTK_MAJOR_VERSION}.${VTK_MINOR_VERSION})
endif()
if(NOT VTK_INSTALL_EXPORT_NAME)
  set(VTK_INSTALL_EXPORT_NAME VTKTargets)
endif()
if(NOT VTK_MODULES_DIR)
  set(VTK_MODULES_DIR "${VTK_BINARY_DIR}/${VTK_INSTALL_PACKAGE_DIR}/Modules")
endif()
if(NOT VTK_WWW_DIR)
  set(VTK_WWW_DIR "${VTK_BINARY_DIR}/www")
endif()
if(NOT VTK_INSTALL_PYTHON_MODULE_DIR)
  set (VTK_INSTALL_PYTHON_MODULE_DIR "-NOTFOUND" CACHE
       PATH "Directory where python modules will be installed")
  mark_as_advanced(VTK_INSTALL_PYTHON_MODULE_DIR)
endif()
if(NOT VTK_BUILD_PYTHON_MODULE_DIR)
  set (VTK_BUILD_PYTHON_MODULE_DIR "-NOTFOUND" CACHE
       PATH "Directory where python modules will be put inside the build tree")
  mark_as_advanced(VTK_BUILD_PYTHON_MODULE_DIR)
endif()
# Full functional CMAKE_CROSSCOMPILING_EMULATOR support for custom_command and
# custom_target is available in CMake 3.8.0
# It was first added in CMake 3.6.0 and later fixed in CMake 3.8.0 (commit e7480d67, CMake issue #16288)
set(_crosscompiling_emulator_support_custom_target 1)
if(CMAKE_VERSION VERSION_LESS 3.8.0)
  set(_crosscompiling_emulator_support_custom_target 0)
endif()
# Maintain backward compatibility with user setting COMPILE_TOOLS_IMPORTED
if(DEFINED COMPILE_TOOLS_IMPORTED AND NOT DEFINED VTK_COMPILE_TOOLS_IMPORTED)
  set(VTK_COMPILE_TOOLS_IMPORTED ${COMPILE_TOOLS_IMPORTED})
endif()
# Variable VTK_COMPILE_TOOLS_IMPORTED is preferred
if(NOT DEFINED VTK_COMPILE_TOOLS_IMPORTED)
  set(VTK_COMPILE_TOOLS_IMPORTED FALSE)
endif()
if(CMAKE_CROSSCOMPILING
    AND NOT VTK_COMPILE_TOOLS_IMPORTED
    AND NOT DEFINED CMAKE_CROSSCOMPILING_EMULATOR
    AND NOT _crosscompiling_emulator_support_custom_target
  )
  # if CMAKE_CROSSCOMPILING is true and crosscompiling emulator is not available, we need
  # to import build-tools targets.
  find_package(VTKCompileTools REQUIRED)
  set(VTK_COMPILE_TOOLS_IMPORTED TRUE)
endif()

#-----------------------------------------------------------------------------
# Add the Remote Subdirectory
add_subdirectory(Remote)

#-----------------------------------------------------------------------------
# Do we try to use system libraries by default?
option(VTK_USE_SYSTEM_LIBRARIES "Use the system's libraries by default." OFF)
mark_as_advanced(VTK_USE_SYSTEM_LIBRARIES)

#-----------------------------------------------------------------------------
# The third party macros are still used in one or two third party builds.
include(vtkThirdParty)

#-----------------------------------------------------------------------------
include(vtkCompilerExtras)
include(vtkBuildPath)

#-----------------------------------------------------------------------------
if(APPLE)
  mark_as_advanced(
    CMAKE_OSX_ARCHITECTURES
    CMAKE_OSX_DEPLOYMENT_TARGET
    CMAKE_OSX_SYSROOT
    )

  if (CMAKE_OSX_DEPLOYMENT_TARGET AND
      CMAKE_OSX_DEPLOYMENT_TARGET VERSION_LESS 10.7)
    message(FATAL_ERROR "Minimun OS X deployment target is 10.7, please update CMAKE_OSX_DEPLOYMENT_TARGET.")
  endif ()
endif()

#-----------------------------------------------------------------------------
# Does VTK require support for 64 bit file systems
INCLUDE(CheckCXXSourceRuns)
FILE(READ "${VTK_CMAKE_DIR}/vtkRequireLargeFilesSupport.cxx"
  VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE)
CHECK_CXX_SOURCE_RUNS("${VTK_REQUIRE_LARGE_FILE_SUPPORT_FILE}"

=== Examples/Catalyst/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
project(CatalystExamples CXX C)

set(USE_CATALYST ON CACHE BOOL "Link the simulator with Catalyst")
if(USE_CATALYST)
  enable_language(CXX)
  find_package(ParaView 4.2 REQUIRED COMPONENTS vtkPVPythonCatalyst)
  include("${PARAVIEW_USE_FILE}")
  add_definitions("-DUSE_CATALYST")
  if(NOT PARAVIEW_USE_MPI)
    message(SEND_ERROR "ParaView must be built with MPI enabled")
  endif()
else()
  find_package(MPI REQUIRED)
  include_directories(${MPI_C_INCLUDE_PATH})
endif()

option(BUILD_TESTING "Build Testing" OFF)
# Setup testing.
if (BUILD_TESTING)
  include(CTest)
endif()

add_subdirectory(CxxOverlappingAMRExample)
add_subdirectory(CxxNonOverlappingAMRExample)
add_subdirectory(CFullExample2)
add_subdirectory(CxxFullExample)
add_subdirectory(CFullExample)
add_subdirectory(CxxVTKPipelineExample)
add_subdirectory(CxxImageDataExample)
add_subdirectory(CxxMultiPieceExample)
add_subdirectory(CxxPVSMPipelineExample)
add_subdirectory(CxxMappedDataArrayExample)
add_subdirectory(MPISubCommunicatorExample)
add_subdirectory(PythonDolfinExample)
add_subdirectory(CxxParticlePathExample)
add_subdirectory(CxxSOADataArrayExample)

set(BUILD_FORTRAN_EXAMPLES OFF CACHE BOOL "Build Fortran Catalyst Examples")
if(BUILD_FORTRAN_EXAMPLES)
  # Theoretically, CheckFortran should not be needed, but
  # enable_language(OPTIONAL) fails with Ninja generator.
  include(CheckFortran)
  if(CMAKE_Fortran_COMPILER)
    enable_language(Fortran OPTIONAL)
  endif()
  if(CMAKE_Fortran_COMPILER_WORKS)
    add_subdirectory(Fortran90FullExample)
    add_subdirectory(FortranPoissonSolver)
  endif()
endif()

=== Plugins/AcceleratedAlgorithms/CMakeLists.txt ===
#--------------------------------------------------
# Find and Use ParaView
#--------------------------------------------------
IF (ParaView_SOURCE_DIR)
  INCLUDE_DIRECTORIES(
    ${VTK_INCLUDE_DIRS}
  )
ELSE ()
  FIND_PACKAGE(ParaView REQUIRED)
  INCLUDE(${PARAVIEW_USE_FILE})
ENDIF ()

ADD_PARAVIEW_PLUGIN(AcceleratedAlgorithms "1.0"
  SERVER_MANAGER_XML AcceleratedAlgorithms.xml
  REQUIRED_ON_SERVER)

=== Plugins/AdiosStagingReader/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Find and Use ParaView
#------------------------------------------------------------------------------
if (ParaView_SOURCE_DIR)
  include_directories(
    ${PARAVIEW_INCLUDE_DIRS}
    ${PARAVIEW_GUI_INCLUDE_DIRS}
    ${PARAVIEW_KWSYS_INCLUDE_DIRS}
    ${VTK_INCLUDE_DIRS}
  )
else()
  find_package(ParaView REQUIRED)
  include(${PARAVIEW_USE_FILE})
endif()


find_package(MPI)
find_package(ADIOS REQUIRED)

include_directories(
  SYSTEM ${ADIOS_INCLUDE_DIRS}
  SYSTEM ${MPI_INCLUDE_PATH}
)

add_paraview_plugin(AdiosStagingReader "1.4"
  SERVER_MANAGER_XML
    AdiosStagingReader.xml
  SERVER_MANAGER_SOURCES
    vtkCartisoReader.cxx
)

target_link_libraries(AdiosStagingReader
  LINK_PRIVATE ${ADIOS_LIBRARIES} ${MPI_LIBRARIES}
)

=== Plugins/ArrowGlyph/CMakeLists.txt ===
include_directories(
  ${VTK_INCLUDE_DIRS})

add_paraview_plugin(ArrowGlyph "1.0" 

  SERVER_MANAGER_XML 
    vtkArrowGlyphFilter.xml
  SERVER_MANAGER_SOURCES
    vtkArrowGlyphFilter.cxx
)

=== Plugins/CDIReader/CMakeLists.txt ===
include_directories(
  ${PARAVIEW_INCLUDE_DIRS}
  ${PARAVIEW_GUI_INCLUDE_DIRS}
  ${PARAVIEW_KWSYS_INCLUDE_DIRS}
  ${VTK_INCLUDE_DIRS}
  )
add_definitions(-DHAVE_NETCDF2)
vtk_module_load(vtknetcdfcpp)
if (NOT VTK_USE_SYSTEM_HDF5 OR HDF5_HL_LIBRARY OR HDF5_hdf5_hl_LIBRARY)
  add_definitions(-DHAVE_NETCDF4)
endif ()
add_paraview_plugin(CDIReader "1.0"
  SERVER_MANAGER_XML CDIReader.xml
  SERVER_MANAGER_SOURCES
    vtkCDIReader.cxx
    cdilib.c
  REQUIRED_ON_SERVER
)
set_source_files_properties(cdilib.c
  PROPERTIES COMPILE_FLAGS -std=c99)
target_link_libraries(CDIReader LINK_PRIVATE ${vtknetcdfcpp_LIBRARIES})

=== Plugins/EyeDomeLighting/CMakeLists.txt ===
project(EyeDomeLighting)
cmake_minimum_required(VERSION 3.3)

if(NOT ParaView_SOURCE_DIR)
  find_package(ParaView)
  include("${PARAVIEW_USE_FILE}")
  include (ParaViewPlugins)

  # Load information about VTK/ParaView modules loaded/available.
  pv_setup_module_environment("EyeDomeLighting")
else()
  # we're building from within ParaView Source.
endif()

if(VTK_RENDERING_BACKEND STREQUAL "OpenGL")
  # process all vtk-modules defined in this plugin. This generates the necessary
  # wrappings for all these modules as well.
  pv_process_modules()
endif()

# Process the ParaView plugin.
add_subdirectory(ParaViewPlugin)

=== Plugins/SierraPlotTools/CMakeLists.txt ===
# This plugin contains tools developed for
# The Computational Solid Mechanics & Dynamics group(s) at Sandia National Labortories
# to make it easier to plot variables from Sierra-based finite
# element simulations.
# Author:  Jon Goldman
# Created:  Aug 2009 -to- Jan 2010

SET(PLUGIN_NAME SierraPlotTools)
SET(PLUGIN_VERSION "1.0")

#
# This macro changes the Visual Studio warning levels from 3 to 4,
#  to catch things such as "unreferenced local variable"
#
MACRO(VS_SET_VS_WARNING_4)
  IF(CMAKE_BUILD_TOOL MATCHES "(msdev|devenv|nmake)")
    #MESSAGE(WARNING "CMAKE_BUILD_TOOL MATCHES msdev|devenv|nmake")

    add_definitions(-DDISABLE_NOISY_COMPILE_WARNINGS)

    # Use the highest warning level for visual studio.
    SET(CMAKE_CXX_WARNING_LEVEL 4)
    IF(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
     STRING(REGEX REPLACE "/W[0-4]" "/W4"
            CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    ELSE()
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    ENDIF()
  ENDIF()
ENDMACRO()

# Comment out VS_SET_VS_WARNING_4 to keep default Visual Studio Warning level 3
# unComment VS_SET_VS_WARNING_4 to change Visual Studio Warning level to 4
#VS_SET_VS_WARNING_4()

INCLUDE_DIRECTORIES(
  ${VTK_INCLUDE_DIRS}
  )

SET(UI_FILES
  # pqSierraPlotToolsActionHolder.ui -- container for plot tools actions
  pqSierraPlotToolsActionHolder.ui
  
  pqSierraPlotToolsDataLoadManager.ui
  pqVariablePlot.ui
  
  # pqSierraToolsRichTextDocs.ui -- container for Rich Text documents
  pqSierraToolsRichTextDocs.ui
  )

SET(MOC_HEADERS
  pqElementPlotter.h
  pqHoverLabel.h
  pqGlobalPlotter.h
  pqNodePlotter.h
  pqPlotVariablesDialog.h
  pqPlotter.h
  pqResizingScrollArea.h
  pqSierraPlotToolsActionGroup.h
  pqSierraPlotToolsDataLoadManager.h
  pqSierraPlotToolsManager.h
  pqVariableVariablePlotter.h
  )

SET(HEADERS
  ${MOC_HEADERS}
  pqSierraPlotToolsUtils.h
  warningState.h
  )

SET(CLIENT_SRCS
  pqElementPlotter.cxx
  pqGlobalPlotter.cxx
  pqHoverLabel.cxx
  pqNodePlotter.cxx
  pqPlotVariablesDialog.cxx
  pqPlotter.cxx
  pqResizingScrollArea.cxx
  pqSierraPlotToolsActionGroup.cxx
  pqSierraPlotToolsDataLoadManager.cxx
  pqSierraPlotToolsManager.cxx
  pqSierraPlotToolsUtils.cxx
  pqVariableVariablePlotter.cxx
  )

IF (PARAVIEW_BUILD_QT_GUI)
  INCLUDE (ParaViewQt)
  pv_find_package_qt(qt_targets REQUIRED QT4_COMPONENTS QtGui QT5_COMPONENTS Widgets)
  pv_qt_wrap_cpp(MOC_SRCS ${MOC_HEADERS})
  pv_qt_wrap_ui(UI_SRCS ${UI_FILES})
  ADD_PARAVIEW_ACTION_GROUP(SIERRA_PLOT_TOOLS_TOOLBAR_IFACE SIERRA_PLOT_TOOLS_TOOLBAR_IFACE_SRCS
    CLASS_NAME pqSierraPlotToolsActionGroup
    GROUP_NAME "ToolBar/SierraTools"
    )
  ADD_PARAVIEW_PLUGIN(${PLUGIN_NAME} ${PLUGIN_VERSION}
    GUI_INTERFACES ${SIERRA_PLOT_TOOLS_TOOLBAR_IFACE}
    GUI_RESOURCES SierraPlotTools.qrc
    SOURCES  ${HEADERS}  ${MOC_SRCS} ${UI_SRCS} ${SIERRA_PLOT_TOOLS_TOOLBAR_IFACE_SRCS} ${CLIENT_SRCS}
    )
  target_link_libraries(${PLUGIN_NAME} LINK_PRIVATE vtkPVVTKExtensionsDefault ${qt_targets})
ELSE ()
ENDIF ()

=== Plugins/VR/CMakeLists.txt ===
# Create an auto-start plugin. Auto start plugins provide callbacks that get
# called when the plugin is loaded and when the application shutsdown.

cmake_minimum_required(VERSION 3.3)

# Find and Include ParaView
if(NOT ParaView_SOURCE_DIR)
  FIND_PACKAGE(ParaView REQUIRED)
  INCLUDE(${PARAVIEW_USE_FILE})
else()
  include_directories(${VTK_INCLUDE_DIRS})
endif()

include(ParaViewQt)
pv_find_package_qt(qt_targets REQUIRED
                QT4_COMPONENTS QtGui QtNetwork
                QT5_COMPONENTS Widgets Network)

# Checks to see if we want to use VRPN or VRUI.
# Both are disabled by default.
SET(PARAVIEW_USE_VRPN OFF CACHE BOOL "Build ParaView with VRPN support")
SET(PARAVIEW_USE_VRUI OFF CACHE BOOL "Build ParaView with VRUI support")

# if VRPN
mark_as_advanced(VRPN_LIBUSB_INCLUDE_DIR)
mark_as_advanced(VRPN_INCLUDE_DIR)
mark_as_advanced(VRPN_LIBRARY)
if(PARAVIEW_USE_VRPN)
  if(NOT EXISTS VRPN_INCLUDE_DIR)
    find_path(VRPN_INCLUDE_DIR vrpn_Tracker.h)
  endif()
  if(UNIX AND NOT APPLE)
    find_path(VRPN_LIBUSB_INCLUDE_DIR libusb.h PATHS /usr/include /usr/local/include)
    if(NOT EXISTS VRPN_LIBUSB_INCLUDE_DIR)
      # Not all platforms require this directory to be set
      set(VRPN_LIBUSB_INCLUDE_DIR "")
      mark_as_advanced(CLEAR VRPN_LIBUSB_INCLUDE_DIR)
    endif()
  endif()
  find_library(VRPN_LIBRARY vrpn)
  set(VRPN_MOC_SRC
    pqVRPNConnection.h
    pqVRPNEventListener.h
  )
  set(VRPN_SOURCE_FILES
    pqVRPNConnection.cxx
    pqVRPNEventListener.cxx
    vtkVRPNCallBackHandlers.cxx)
endif()

# if VRUI
if(PARAVIEW_USE_VRUI)
  set(VRUI_MOC_SRC pqVRUIConnection.h)
  set(VRUI_SOURCE_FILES
    pqVRUIConnection.cxx
    vtkVRUIPipe.cxx
    vtkVRUIServerState.cxx
    vtkVRUITrackerState.cxx)
endif()

pv_qt_wrap_cpp(MOC_SRCS
  pqVRAddConnectionDialog.h
  pqVRAddStyleDialog.h
  pqVRConnectionManager.h
  pqVRDockPanel.h
  pqVRQueueHandler.h
  pqVRStarter.h
  ${VRPN_MOC_SRC}
  ${VRUI_MOC_SRC}
  )

pv_qt_wrap_ui(UI_SRCS
  pqVRDockPanel.ui
  pqVRAddConnectionDialog.ui
  pqVRAddStyleDialog.ui
  )

if(PARAVIEW_USE_VRPN)
  INCLUDE_DIRECTORIES(${VRPN_INCLUDE_DIR} ${VRPN_LIBUSB_INCLUDE_DIR})
endif()

SET( VR_SOURCE_FILES
  pqVRConnectionManager.cxx
  pqVRQueueHandler.cxx
  ${VRPN_SOURCE_FILES}
  ${VRUI_SOURCE_FILES}
  vtkVRControlSliceOrientationStyle.cxx
  vtkVRControlSlicePositionStyle.cxx
  vtkVRGrabWorldStyle.cxx
  vtkVRInteractorStyle.cxx
  vtkVRInteractorStyleFactory.cxx
  vtkVRQueue.cxx
  vtkVRTrackStyle.cxx
  vtkVRSpaceNavigatorGrabWorldStyle.cxx
  vtkVRVirtualHandStyle.cxx
  ${MOC_SRCS})

ADD_PARAVIEW_AUTO_START(IFACES IFACE_SRCS CLASS_NAME pqVRStarter
                        STARTUP onStartup
                        SHUTDOWN onShutdown)

ADD_PARAVIEW_DOCK_WINDOW(
  IFACES_WINDOW IFACES_SRCS_WINDOW
  CLASS_NAME pqVRDockPanel
  DOCK_AREA Left)

# create a plugin for this starter
ADD_PARAVIEW_PLUGIN(
  VRPlugin "1.0"
  GUI_INTERFACES ${IFACES} ${IFACES_WINDOW}
  GUI_SOURCES
          pqVRAddConnectionDialog.cxx
          pqVRAddStyleDialog.cxx
          pqVRDockPanel.cxx
          pqVRStarter.cxx
          ${MOC_SRCS}
          ${VR_SOURCE_FILES}
          ${RCS_SRCS} ${IFACE_SRCS} ${IFACES_SRCS_WINDOW}
          ${UI_SRCS}
          )

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/vtkPVVRConfig.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/vtkPVVRConfig.h
  ESCAPE_QUOTES IMMEDIATE)

# if VRPN is used then link to VRPN library
if(PARAVIEW_USE_VRPN)
  target_link_libraries (VRPlugin LINK_PRIVATE "${VRPN_LIBRARY}")
endif()

target_link_libraries (VRPlugin
  LINK_PRIVATE
    pqApplicationComponents
    vtkPVServerManagerRendering
    ${qt_targets}
)

=== Plugins/VTKm/CMakeLists.txt ===
if(ParaView_SOURCE_DIR)
  include_directories(
    ${VTK_INCLUDE_DIRS}
  )
else()
  find_package(ParaView REQUIRED)
  include(${PARAVIEW_USE_FILE})
endif()

# This plugin relies on classes in the vtkAcceleratorsVTKm VTK module, which
# is not built by default because the server manager XML points to classes
# in this module. Usually you could get this module to build by adding this
# module to a module.cmake file. However, we are not actually building our
# own source, so we can't really do it. For now, just instruct the user to
# turn it on manually.
if(NOT Module_vtkAcceleratorsVTKm)
  message(SEND_ERROR "VTKm plugin requires vtkAcceleratorsVTKm module. Please turn on Module_vtkAcceleratorsVTKm CMake option.")
endif()

add_paraview_plugin(VTKmFilters "0.1"
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  SERVER_MANAGER_XML VTKmSM.xml
  )
target_link_libraries(VTKmFilters LINK_PRIVATE vtkAcceleratorsVTKm)

# Add testing if necessary
if (BUILD_TESTING)
  add_subdirectory(Testing)
endif ()

=== debian/changelog ===
paraview (5.4.1+dfsg4-4) unstable; urgency=medium

  * Team upload.
  * [64c0c0d] Trim trailing whitespace.
  * [bcf3d00] Use secure URI in Homepage field.
  * [c5cb7ab] Add Alastair as an uploader.
  * [5119941] Fix indents.

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Aug 2019 10:24:34 +0200

paraview (5.4.1+dfsg4-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream FTBFS fixes, thanks to Juhani Numminen.
    (Closes: #906714)
  * Remove tcl8.5 as first dependency alternative. (Closes: #905980)

 -- Adrian Bunk <bunk@debian.org>  Mon, 17 Sep 2018 19:59:09 +0300

paraview (5.4.1+dfsg4-3) unstable; urgency=medium

  * Team upload
  * d/p/disable-local-FindMPI: fix FTBS with latest openmpi
  * d/ruled: Remove forced MPI include path, it is no longer valid

 -- Gert Wollny <gewo@debian.org>  Sun, 22 Apr 2018 12:35:56 +0200

paraview (5.4.1+dfsg4-2) unstable; urgency=medium

  * Team upload.
  * [bd12fc4] d/p/fix_opengl_arm: use Extra OpenGL functions
    Closes: #893735

 -- Gert Wollny <gewo@debian.org>  Fri, 23 Mar 2018 22:47:21 +0000

paraview (5.4.1+dfsg4-1) unstable; urgency=medium

  * Team upload.
  * [a7b9430] New upstream version 5.4.1+dfsg4
  * [117a771] Use backend OpenGL2
  * [c5d2240] d/p/fix_gl2ps Update OpenGL2 backend
  * [145a06f] d/rules: Switch to qt5
  * [a7aaa49] d/control: Switch to qt5
  * [fa81501] d/copyright: remove duplicate BSD-3-clause section
  * [033db76] d/source: Add some overrides for the package

 -- Gert Wollny <gewo@debian.org>  Thu, 15 Mar 2018 19:02:28 +0100

paraview (5.4.1+dfsg3-2) unstable; urgency=medium

  * Team upload.

  [ Gert Wollny ]
  * [d289ee3] d/copyright: update copyright based on the ftp-master comments for vtk7

  [ Anton Gladky ]
  * [e9be492] Remove deprecated Testsuite-field
  * [4952ac8] Set compat level to 11
  * [f2d150a] Set priority optional
  * [f122067] Set Standards-Versions: 4.1.3
  * [c19be5e] Update VCS-fields
  * [762408d] Apply cme fix dpkg
  * [c1cfeae] Remove myself from uploaders

 -- Anton Gladky <gladk@debian.org>  Wed, 07 Mar 2018 21:00:16 +0100

=== debian/control ===
Source: paraview
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11),
               cmake,
               qtbase5-dev,
               libqt5opengl5-dev,
               libqt5x11extras5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               qttools5-private-dev,
               qtxmlpatterns5-dev-tools,
               libsqlite3-dev,
               libboost-all-dev,
               libavformat-dev,
               gfortran,
               libavutil-dev,
               libcgns-dev,
               libprotobuf-dev,
               protobuf-compiler,
               libavcodec-dev,
               libswscale-dev,
               libqt5sql5-sqlite,
               python-dev,
               dh-python,
               libglu1-mesa-dev,
               libxt-dev,
               python-all,
               python-all-dev,
               python-all-dev (<< 2.8),
               libxext-dev,
               doxygen,
               graphviz,
               gnuplot,
               libtiff-dev,
               libpng-dev,
               libjpeg-dev,
               libxml2-dev,
               libexpat-dev,
               zlib1g-dev,
               libfreetype6-dev,
               default-libmysqlclient-dev,
               libpq-dev,
               libtheora-dev,
               libogg-dev,
               mpi-default-dev,
               mpi-default-bin,
               libhdf5-dev,
               hdf5-tools,
               libgl2ps-dev,
               libeigen3-dev,
               libnetcdf-dev,
               libnetcdf-cxx-legacy-dev,
               libjsoncpp-dev,
               libglew-dev,
               libxdmf-dev,
               libutfcpp-dev,
               python-autobahn,
               python-matplotlib,
               python-mpi4py,
               python-six,
               python-twisted
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/paraview
Vcs-Git: https://salsa.debian.org/science-team/paraview.git
Homepage: https://www.paraview.org/

Package: paraview
Architecture: any
Depends: tclsh,
         ${shlibs:Depends},
         ${misc:Depends},
         python-matplotlib,
         python-autobahn,
         python-mpi4py,
         python-six,
         python-twisted
Recommends: mpi-default-bin,
            paraview-python,
            paraview-doc
Suggests: hdf5-tools,
          h5utils
Description: Parallel Visualization Application
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt.

Package: paraview-dev
Architecture: any
Section: libdevel
Depends: qt4-dev-tools,
         ${shlibs:Depends},
         ${misc:Depends},
         paraview (= ${binary:Version}),
         libeigen3-dev
Description: Parallel Visualization Application. Development header files
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt. Development header files

Package: paraview-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: paraview
Description: Parallel Visualization Application. Comprehensive documentation
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt. Comprehensive documentation.

Package: paraview-python
Architecture: any
Section: python
Depends: paraview (= ${binary:Version}),
         ${python:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
         python,
         python (<< 2.8),
         python-vtk6
Provides: ${python:Provides}
Description: Parallel Visualization Application. python-support
 ParaView is an open-source, multi-platform application designed to
 visualize data sets of size varying from small to very large. The
 goals of the ParaView project include the following:
 .
     * Develop an open-source, multi-platform visualization application.
     * Support distributed computation models to process large data sets.
     * Create an open, flexible, and intuitive user interface.
     * Develop an extensible architecture based on open standards.
 .
 ParaView runs on distributed and shared memory parallel as well as
 single processor systems and has been successfully tested on Windows,
 Mac OS X, Linux and various Unix workstations, clusters and
 supercomputers. Under the hood, ParaView uses the Visualization
 Toolkit as the data processing and rendering engine and has a user
 interface written using Qt. Enables python support.

=== debian/rules ===
#! /usr/bin/make -f
#export DH_VERBOSE=1

DESTDIR = $(CURDIR)/debian/tmp
UPSTREAM_VERSION = $(shell dpkg-parsechangelog | awk '/^Version:/ { sub("-[^-]*$$", "", $$2); print $$2}')

%:
	dh $@ --with python2

export LD_LIBRARY_PATH+=:$(CURDIR)/debian/paraview/usr/lib/paraview
export QT_SELECT=qt5

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) -Wall -pedantic
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# Explicit settings of MPI_* is required see
# http://www.vtk.org/Bug/view.php?id=12572
PYVER = $(shell pyversions -dv)
extra_flags += -Wno-dev \
	-DBUILD_DOCUMENTATION=ON \
	-DCMAKE_INSTALL_RPATH=/usr/lib/paraview \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF  \
	-DCMAKE_SKIP_RPATH=OFF \
 	-DPARAVIEW_ENABLE_FFMPEG=ON \
	-DPARAVIEW_ENABLE_WEB=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_TESTING=OFF \
	-DVTK_USE_MPEG2_ENCODER=OFF \
 	-DVTK_USE_FFMPEG_ENCODER=ON \
	-DVTK_USE_OGGTHEORA_ENCODER=ON \
	-DVTK_USE_SYSTEM_FREETYPE=ON \
	-DVTK_USE_SYSTEM_CGNS=ON \
	-DVTK_USE_SYSTEM_PROTOBUF=ON \
	-DVTK_USE_SYSTEM_GL2PS=ON \
	-DVTK_USE_SYSTEM_JPEG=ON \
	-DVTK_USE_SYSTEM_JSONCPP=ON \
	-DVTK_USE_SYSTEM_NETCDF=ON \
	-DVTK_USE_SYSTEM_GLEW=ON \
	-DVTK_USE_SYSTEM_PNG=ON \
	-DVTK_USE_SYSTEM_OGGTHEORA=ON \
	-DVTK_USE_SYSTEM_TIFF=ON \
	-DVTK_USE_SYSTEM_ZLIB=ON \
	-DVTK_USE_SYSTEM_LIBXML2=ON \
	-DVTK_USE_SYSTEM_EXPAT=ON \
	-DVTK_USE_SYSTEM_MPI4PY=ON \
	-DVTK_USE_SYSTEM_HDF5=ON \
	-DHDF5_INCLUDE_DIRS="/usr/include/hdf5/serial" \
	-DHDF5_IS_PARALLEL=OFF \
	-DVTK_INSTALL_LIBRARY_DIR="lib/paraview" \
	-DVTK_INSTALL_ARCHIVE_DIR="lib/paraview" \
	-DVTK_INSTALL_INCLUDE_DIR="include/paraview" \
	-DVTK_INSTALL_DATA_DIR="share/paraview" \
	-DVTK_INSTALL_DOC_DIR="share/doc/paraview" \
	-DVTK_INSTALL_PACKAGE_DIR="lib/cmake/paraview" \
	-DVTK_CUSTOM_LIBRARY_SUFFIX="" \
	-DBUILD_EXAMPLES=OFF \
	-DDOCUMENTATION_HTML_HELP=ON \
	-DPARAVIEW_INSTALL_DEVELOPMENT_FILES=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DPARAVIEW_USE_MPI=ON \
	-DPARAVIEW_ENABLE_PYTHON=ON \
	-DPARAVIEW_BUILD_PLUGIN_AdiosReader:BOOL=ON \
	-DPARAVIEW_BUILD_PLUGIN_EyeDomeLighting:BOOL=ON \
	-DPARAVIEW_BUILD_PLUGIN_MobileRemoteControl=OFF \
	-DEigen_DIR=/usr/include/eigen3 \
	-DPARAVIEW_BUILD_WEB_DOCUMENTATION=ON \
	-DVTK_RENDERING_BACKEND:STRING=OpenGL2 \
	-DPARAVIEW_QT_VERSION=5 \
	-DVTK_INSTALL_NO_DOCUMENTATION=ON

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_compress:
	dh_compress -X.qch

override_dh_install:
	dh_install --list-missing
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_makeshlibs:
	dh_makeshlibs -V'paraview (>= $(UPSTREAM_VERSION)), paraview (<< $(UPSTREAM_VERSION).)'
